unit Unit23;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Grids, Printers;

type
  TFenBilanC = class(TForm)
    LabelSommeC: TLabel;
    TabBilanC: TStringGrid;
    BitBtn1: TBitBtn;
    BtnImpression: TButton;
    Label1: TLabel;
    PrintDialogC: TPrintDialog;
    Label2: TLabel;
    Label3: TLabel;
    LabelTTC: TLabel;
    LabelTTI: TLabel;
    procedure BitBtn1Click(Sender: TObject);
    procedure BtnImpressionClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  FenBilanC: TFenBilanC;

implementation

Uses Unit1;

{$R *.DFM}

procedure TFenBilanC.BitBtn1Click(Sender: TObject);
begin
     FenBilanC.Close;
end;

procedure TFenBilanC.BtnImpressionClick(Sender: TObject);

Var
   FichBilanI     : TextFile;
   TmpStr         : String[25];
   NumPage        : String[6];
   Ctr, x, HautPage, InterLigne, NbrCopies, NumCop : Integer;
   LignesParPage  : Integer;
   Ligne          : Array[1..2000] Of String[150];
   NbLigne, NbCol : Integer;
   SommeTot       : Real;
   i,j, k         : Integer;
   HrU, MnU, HrNU, MnNU : Integer;

Begin
     Ligne[1] :='';
     k := 1;
     AssignFile(FichBilanI, NomFichConsult);
     Reset(FichBilanI);
     ReadLn(FichBilanI, NbLigne);
     ReadLn(FichBilanI, NbCol);
     ReadLn(FichBilanI, TempsUtilise);
     ReadLn(FichBilanI, TempsNonUtilise);
     ReadLn(FichBilanI, SommeTot);
     For j:=1 To NbLigne Do
       For i:=1 To NbCol Do
           Begin
                ReadLn(FichBilanI, TmpStr);
                Ligne[j] := Ligne[j] + '      ' + TmpStr
           End;
     CloseFile(FichBilanI);
     If PrintDialogC.Execute Then
     Begin
          Ctr := 1;
          NbrCopies  := PrintDialogC.Copies;
          For NumCop:=1 To NbrCopies Do
          Begin
               x := 650; Ctr := 0;
               Printer.BeginDoc;
               HautPage := Printer.PageHeight;
               Printer.Canvas.Font.Size := TaillePolice;
               Printer.Canvas.Font.Name := NomPolice;
               Printer.Canvas.Font.Style := StylePolice;
               LignesParPage := HautPage Div 130;
               InterLigne := HautPage Div LignesParPage;
               NumPage := IntToStr(Printer.PageNumber);
               Printer.Canvas.TextOut(100,100, 'International Computer Services (I.C.S.)');
               Printer.Canvas.TextOut(100,300, NomFichConsult);
               Printer.Canvas.TextOut(0,500,'          Poste'+'           Dbut'+
               '                          Fin'+'                       Temps (mn)'+
               '         Profil'+'         Somme (DA)');
               For j:=1 To NbLigne Do
               Begin
                    Printer.Canvas.TextOut(0, x, Ligne[j]);
                    x := x + InterLigne;
                    Ctr := Ctr + 1;
                    If Ctr > LignesParPage-1 Then
                    Begin
                         Printer.NewPage;
                         x   := 0;
                         Ctr := 0;
                         NumPage := IntToStr(Printer.PageNumber);
                    End;
               End;
          HrNU :=  Trunc(TempsNonUtilise/3600);
          MnNU := Round((TempsNonUtilise - (HrNU*3600))/60);
          HrU :=  Trunc(TempsUtilise/3600);
          MnU := Round((TempsUtilise - (HrU*3600))/60);

          Printer.Canvas.TextOut(100, x+100, 'Temps Total Utilis =  '+
                                 IntToStr(HrU)+ ' h ' + IntToStr(MnU)+ ' mn.');
          Printer.Canvas.TextOut(100, x+200, 'Temps Total Non Utilis =  '+
                                 IntToStr(HrNU)+ ' h ' + IntToStr(MnNU)+ ' mn.');
          Printer.Canvas.TextOut(100, x+300, 'Recette jounalire =  '+
                                 FormatFloat('0.00',SommeTot) +' DA.');
          Printer.EndDoc;
          End;
     End;
End;

End.
