unit Unit11;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TPoste7 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    TempDebut: TLabel;
    TempFin: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    TempCon: TLabel;
    PrixCon: TLabel;
    Label9: TLabel;
    NumPost: TLabel;
    BoutReinit: TButton;
    BoutCompt: TButton;
    RadioGroup1: TRadioGroup;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    procedure BoutReinitClick(Sender: TObject);
    procedure BoutComptClick(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Poste7: TPoste7;
  TempTotDebut, TempTotFin, TempTotCon : Integer;
  PrixTotCon : Real;
  TDebCon, TFinCon, Profile : String;
  ReinitOk : Boolean;

implementation

uses Unit1, Unit3, Unit5, Unit25;

{$R *.DFM}
{===============================================}
Procedure TPoste7.BoutReinitClick(Sender: TObject);
Var
  Present: TDateTime;
  Heure, Min, Sec, MSec: Word;

Begin
     If (ReinitOk = False) And (InterGen = False) Then
     Begin
          TempTotInt[7]  := 0;
          ReinitOk := True;
          TempDebut.Caption := '0';
          TempFin.Caption := '0';
          TempCon.Caption := '0';
          PrixCon.Caption := '0';
          FenPrincipale.Shape7.Brush.Color := clRed;

          Present:= Now;
          DecodeTime(Present, Heure, Min, Sec, MSec);
          TempDebut.Caption := IntToStr(Heure)+'  h ' + IntToStr(Min)+'  mn '
                      +IntToStr(Sec)+'  s';
          TDebCon := IntToStr(Heure)+'  h ' + IntToStr(Min)+'  mn '
                      +IntToStr(Sec)+'  s';
          TempTotDebut := Heure*3600 + Min*60 + Sec;
     End
     Else MessageDlg(' Le poste ne peut tre fonctionnel puisqu''il y a une dconnexion'+
                      ', ou bien vous avez oublier de comptabiliser!',
                          mtWarning, [mbOk], 0);
end;

{===============================================}
Procedure TPoste7.BoutComptClick(Sender: TObject);
Var
  Present: TDateTime;
  Heure, Min, Sec, MSec: Word;

Begin
     If ReinitOk = True Then
     Begin
          ReinitOk := False;
          FenPrincipale.Shape7.Brush.Color := clLime;
          Present:= Now;
          DecodeTime(Present, Heure, Min, Sec, MSec);
          TempFin.Caption := IntToStr(Heure)+'  h ' + IntToStr(Min)+'  mn '
                      +IntToStr(Sec)+'  s';
          TFinCon := IntToStr(Heure)+'  h ' + IntToStr(Min)+'  mn '
                      +IntToStr(Sec)+'  s';
          TempTotFin := Heure*3600 + Min*60 + Sec;
          TempTotCon := TempTotFin - TempTotDebut;
          If Inter7=True Then TempTotCon := TempTotFin - TempTotDebut - TempTotInt[7];
          TempCon.Caption := IntToStr(Round(TempTotCon/60))+ ' mn';
          //TempsUtilise := TempsUtilise + TempTotCon;

          AssignFile(FichPrix, 'Prix');
          Reset(FichPrix);
          ReadLn(FichPrix,PUHSF);
          ReadLn(FichPrix,PUHAF);
          ReadLn(FichPrix,PUHPF);
          CloseFile(FichPrix);

          PrixUnitS := StrToInt(PUHSF);
          PrixUnitA := StrToInt(PUHAF);
          PrixUnitP := StrToInt(PUHPF);


          If RadioButton1.Checked Then
                                  Begin
                                       PrixTotCon := TempTotCon * PrixUnitS/3600;
                                       Profile := 'Simple';
                                  End;
          If RadioButton2.Checked Then
                                  Begin
                                       PrixTotCon := TempTotCon * PrixUnitA/3600;
                                       Profile := 'Abonn';
                                  End;
          If RadioButton3.Checked Then
                                  Begin
                                       PrixTotCon := TempTotCon * PrixUnitP/3600;
                                       Profile := 'Privilgi';
                                  End;
          PrixCon.Caption := FormatFloat('0.00',PrixTotCon) +' DA';

          NumLigne := Numligne+1;
          SommeAct := SommeAct + PrixTotCon;
          With FenBilan.TabBilan Do
          Begin
               RowCount := NumLigne+1;
               Cells[0,NumLigne]:= '         7';
               Cells[1,NumLigne]:= '  ' + TDebCon;
               Cells[2,NumLigne]:= '  ' + TFinCon;
               Cells[3,NumLigne]:= '               '
                                        + IntToStr(Round(TempTotCon/60));
               Cells[4,NumLigne]:= '      ' + Profile;
               Cells[5,NumLigne]:= '          ' + FormatFloat('0.00',PrixTotCon);
          End;
          FenBilan.Sauve(Sender);
     End;
     Inter7 := False;
End;
{===============================================}

procedure TPoste7.RadioButton2Click(Sender: TObject);
begin
     FenCodeAbonne.Show;
end;

End.
