unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, Buttons, Printers;

type
  TFenBilan = class(TForm)
    TabBilan: TStringGrid;
    BitBtn1: TBitBtn;
    BtnImpression: TButton;
    Label1: TLabel;
    BtnConsult: TButton;
    SpeedButton1: TSpeedButton;
    OpenDialog1: TOpenDialog;
    PrintDialogI: TPrintDialog;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Label2: TLabel;
    Label3: TLabel;
    procedure BitBtn1Click(Sender: TObject);
    procedure Sauve(Sender: TObject);
    procedure BtnImpressionClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure BtnConsultClick(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
  private
    { Dclarations prives}
  public
    { Dclarations publiques}
  end;

var
  FenBilan: TFenBilan;
  NomFichBilan : String;

implementation

uses Unit1, Unit23;

{$R *.DFM}

procedure TFenBilan.BitBtn1Click(Sender: TObject);
begin
     FenBilan.Close;
end;

procedure TFenBilan.Sauve(Sender: TObject);

Var
   i, j   : Integer;
   FichBilan : TextFile;
   Present: TDateTime;
   An, Moi, Jour : Word;
begin
     Present:= Now;
     DecodeDate(Present, An, Moi, Jour);
     NomFichBilan := 'Bil-' + IntToStr(Jour) + '-' + IntTostr(Moi) + '-' +
                              IntToStr(An) + '.txt';

     AssignFile(FichBilan, NomFichBilan);
     ReWrite(FichBilan);
     With TabBilan Do
     Begin
          Writeln(FichBilan, RowCount);
          WriteLn(FichBilan, ColCount);
          WriteLn(FichBilan, TempsUtilise);
          WriteLn(FichBilan, TempsNonUtilise);
          WriteLn(FichBilan, SommeAct);
          For j := 1 To RowCount - 1 Do
          For i:= 0 To ColCount - 1 Do
          Begin
               WriteLn(FichBilan,Cells[i,j]);
          End;
     End;
     CloseFile(FichBilan);
end;

procedure TFenBilan.BtnImpressionClick(Sender: TObject);

Var
   FichBilanI     : TextFile;
   TmpStr         : String[25];
   NumPage        : String[6];
   Ctr, x, HautPage, InterLigne, NbrCopies, NumCop : Integer;
   LignesParPage  : Integer;
   Ligne          : Array[1..2000] Of String[150];
   NbLigne, NbCol : Integer;
   SommeTot       : Real;
   i,j, k         : Integer;
   HrU, MnU, HrNU, MnNU : Integer;

Begin
     Ligne[1] :='';
     k := 1;
     AssignFile(FichBilanI, NomFichBilan);
     Reset(FichBilanI);
     ReadLn(FichBilanI, NbLigne);
     ReadLn(FichBilanI, NbCol);
     ReadLn(FichBilanI, TempsUtilise);
     ReadLn(FichBilanI, TempsNonUtilise);
     ReadLn(FichBilanI, SommeTot);
     For j:=1 To NbLigne Do
       For i:=1 To NbCol Do
           Begin
                ReadLn(FichBilanI, TmpStr);
                Ligne[j] := Ligne[j] + '      ' + TmpStr
           End;
     CloseFile(FichBilanI);
     If PrintDialogI.Execute Then
     Begin
          Ctr := 1;
          NbrCopies  := PrintDialogI.Copies;
          For NumCop:=1 To NbrCopies Do
          Begin
               x := 650; Ctr := 0;
               Printer.BeginDoc;
               HautPage := Printer.PageHeight;
               Printer.Canvas.Font.Size := TaillePolice;
               Printer.Canvas.Font.Name := NomPolice;
               Printer.Canvas.Font.Style := StylePolice;
               LignesParPage := HautPage Div 130;
               InterLigne := HautPage Div LignesParPage;
               NumPage := IntToStr(Printer.PageNumber);
               Printer.Canvas.TextOut(100,100, 'International Computer Services (I.C.S.)');
               Printer.Canvas.TextOut(100,300, NomFichBilan);
               Printer.Canvas.TextOut(0,500,'          Poste'+'           Dbut'+
               '                          Fin'+'                       Temps (mn)'+
               '         Profil'+'         Somme (DA)');
               For j:=1 To NbLigne Do
               Begin
                    Printer.Canvas.TextOut(0, x, Ligne[j]);
                    x := x + InterLigne;
                    Ctr := Ctr + 1;
                    If Ctr > LignesParPage-1 Then
                    Begin
                         Printer.NewPage;
                         x   := 0;
                         Ctr := 0;
                         NumPage := IntToStr(Printer.PageNumber);
                    End;
               End;
          HrNU :=  Trunc(TempsNonUtilise/3600);
          MnNU := Round((TempsNonUtilise - (HrNU*3600))/60);
          HrU :=  Trunc(TempsUtilise/3600);
          MnU := Round((TempsUtilise - (HrU*3600))/60);

          Printer.Canvas.TextOut(100, x+100, 'Temps Total Utilis =  '+
                                 IntToStr(HrU)+ ' h ' + IntToStr(MnU)+ ' mn.');
          Printer.Canvas.TextOut(100, x+200, 'Temps Total Non Utilis =  '+
                                 IntToStr(HrNU)+ ' h ' + IntToStr(MnNU)+ ' mn.');
          Printer.Canvas.TextOut(100, x+300, 'Recette jounalire =  '+
                                 FormatFloat('0.00',SommeTot) +' DA.');
          Printer.EndDoc;
          End;
     End;
End;

procedure TFenBilan.SpeedButton1Click(Sender: TObject);
begin
     Label1.Caption := FormatFloat('0.00',SommeAct) +' DA';
end;

procedure TFenBilan.BtnConsultClick(Sender: TObject);

Var
   i, j           : Integer;
   FichBilanC     : TextFile;
   ValCell        : String[25];
   NbLigne, NbCol : Integer;
   STF            : Real;
   TUF, TNUF      : Integer;
   HrU, MnU, HrNU, MnNU : Integer;

begin
     If OpenDialog1.Execute Then
     Begin
          NomFichConsult := OpenDialog1.FileName;
          AssignFile(FichBilanC, NomFichConsult);
          Reset(FichBilanC);
          ReadLn(FichBilanC, NbLigne);
          ReadLn(FichBilanC, NbCol);
          ReadLn(FichBilanC, TUF);
          ReadLn(FichBilanC, TNUF);
          ReadLn(FichBilanC, STF);
          FenBilanC.Show;
          With FenBilanC.TabBilanC Do
          Begin
               RowCount := NbLigne;
               ColCount := NbCol;
               Cells[0,0]:='  N du Poste';
               Cells[1,0]:='        Dbut';
               Cells[2,0]:='          Fin';
               Cells[3,0]:='  Temps coul (mn)';
               Cells[4,0]:='  Profil utilisateur';
               Cells[5,0]:=' Somme  payer (DA)';
               For j := 0 To RowCount - 1 Do
               For i:= 0 To ColCount - 1 Do
               Begin
                    ReadLn(FichBilanC,ValCell);
                    Cells[i,j+1] := ValCell;
               End;
          End;
          CloseFile(FichBilanC);

          HrNU :=  Trunc(TNUF/3600);
          MnNU := Round((TNUF - (HrNU*3600))/60);
          HrU :=  Trunc(TUF/3600);
          MnU := Round((TUF - (HrU*3600))/60);

          FenBilanC.LabelTTC.Caption := IntToStr(HrU)+ ' h ' + IntToStr(MnU)+ ' mn.';
          FenBilanC.LabelTTI.Caption := IntToStr(HrNU)+ ' h ' + IntToStr(MnNU)+ ' mn.';
          FenBilanC.LabelSommeC.Caption := FormatFloat('0.00',STF) +' DA';
     End;
End;

procedure TFenBilan.SpeedButton2Click(Sender: TObject);

 Var
    Hr, Mn : Integer;

Begin
     Hr :=  Trunc(TempsNonUtilise/3600);
     Mn := Round((TempsNonUtilise - (Hr*3600))/60);
     Label3.Caption := IntToStr(Hr)+ ' h ' + IntToStr(Mn)+ ' mn';
     Sauve(Sender);
end;

procedure TFenBilan.SpeedButton3Click(Sender: TObject);

 Var
    Present: TDateTime;
    Heure, Min, Sec, MSec: Word;
    Hr, Mn : Integer;

Begin
     Present:= Now;
     DecodeTime(Present, Heure, Min, Sec, MSec);
     TempsUtiliseF := Heure*3600 + Min*60 + Sec;
     TempsUtilise := TempsUtiliseF - TempsUtiliseD;
     Hr :=  Trunc(TempsUtilise/3600);
     Mn := Round((TempsUtilise - (Hr*3600))/60);
     Label2.Caption := IntToStr(Hr)+ ' h ' + IntToStr(Mn)+ ' mn';
     Sauve(Sender);
End;

End.
