unit Unit5;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;

type
  TFenConfig = class(TForm)
    AnnulerBtn: TBitBtn;
    OkBtn: TBitBtn;
    GroupBoxPrix: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    PUHS: TEdit;
    PUHA: TEdit;
    PUHP: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Panel1: TPanel;
    BoutPolice: TButton;
    FontDialog1: TFontDialog;
    Label4: TLabel;
    procedure AnnulerBtnClick(Sender: TObject);
    procedure OkBtnClick(Sender: TObject);
    Procedure QuandFenAffichee(Sender: TObject);
    procedure BoutPoliceClick(Sender: TObject);
  private
    { Dclarations prives}
  public
    { Dclarations publiques}
  end;

var
  FenConfig: TFenConfig;
  FichPrix : TextFile;
  PUHSF, PUHAF, PUHPF : String;

implementation

Uses Unit1;

{$R *.DFM}

procedure TFenConfig.AnnulerBtnClick(Sender: TObject);
begin
     FenConfig.Close;
end;

procedure TFenConfig.OkBtnClick(Sender: TObject);
begin
     PUHSF := PUHS.Text;
     PUHAF := PUHA.Text;
     PUHPF := PUHP.Text;

     AssignFile(FichPrix,'Prix');
     ReWrite(FichPrix);
     WriteLn(FichPrix,PUHSF);
     WriteLn(FichPrix,PUHAF);
     WriteLn(FichPrix,PUHPF);
     CloseFile(FichPrix);

     FenConfig.Close;
end;

Procedure TFenConfig.QuandFenAffichee(Sender: TObject);

Begin
     AssignFile(FichPrix,'Prix');
     Reset(FichPrix);
     ReadLn(FichPrix,PUHSF);
     ReadLn(FichPrix,PUHAF);
     ReadLn(FichPrix,PUHPF);
     CloseFile(FichPrix);

     PUHS.Text := PUHSF;
     PUHA.Text := PUHAF;
     PUHP.Text := PUHPF;
End;
procedure TFenConfig.BoutPoliceClick(Sender: TObject);
begin
     If FontDialog1.Execute Then
     Begin
          NomPolice    := FontDialog1.Font.Name;
          TaillePolice := FontDialog1.Font.Size;
          StylePolice  := FontDialog1.Font.Style;
     End;
end;

End.
